var dataController = {
    database: null,
    table: new Array(),
    titleTable: new Object(),
    childrenTable: new Object(),
    parentTable: new Object(),
    graphics: new Array(),
    graphicCacheFromJSON: null,
    databaseVersion: 0,
    configurationSettings: new Object(),
    shouldFlatten: 0,
    shouldHideSearchButton: 0,
    mainTOCBackButtonURL: "",
    mainTOCBackButtonTitle: "",
    title: "",
    alternativeTitle: "",
    showVersionNumber: 0,
    webclipIcon: 0,
    singleViewMode: 0,
    showCopyright: 1,
    showGroupedTopLevel: 0,
};
dataController.init = function(){
    localizationController.localize();
    var a = localizationController.language;
    var b = window.location.href;
    this.dataFolder = b;
    this.dataFolder = this.dataFolder.substring(0, this.dataFolder.lastIndexOf("/"));
    this.dataFolder = this.dataFolder.substring(0, this.dataFolder.lastIndexOf("/"));
    this.dataFolder += "/iPad/Contents/" + a + "/";
    this.dataFolder = this.dataFolder.replace(" ", "%20");
    if (navigator.userAgent.match(/iPhone/)) {
        dataController.singleViewMode = 1
    }
    dataController.initDatabase()
};
dataController.fixNestedSingularChildren = function(){
    for (var b in dataController.childrenTable) {
        var f = dataController.childrenTable[b];
        if (1 != f.length) {
            continue
        }
        if ("TOP_LEVEL_ITEM" == b) {
            continue
        }
        var c = f[0];
        delete dataController.childrenTable[b];
        for (var d in dataController.childrenTable) {
            var e = dataController.childrenTable[d];
            for (var a = 0; a < e.length; a++) {
                if (e[a] == b) {
                    e[a] = c
                }
            }
        }
    }
};
dataController.getChildrenAPDIDsForItemWithAPDID = function(b){
    if (b == undefined) {
        b = ""
    }
    var a = this.childrenTable[b];
    if (!a) {
        a = new Array()
    }
    return a
};
dataController.getTitleForItemWithAPDID = function(c){
    if (c == "TOP_LEVEL_ITEM") {
        var a = dataController.title;
        if (dataController.alternativeTitle) {
            a = dataController.alternativeTitle
        }
        if (!a || a.length == 0) {
            a = " "
        }
        return a
    }
    if (c == "COPYRIGHT_PAGE_CONTENT") {
        return "Copyright"
    }
    if (c == "") {
        return "ERROR! item missing apdid"
    }
    var b = this.titleTable[c];
    if (b) {
        b = this.removeEntities(b)
    }
    return b
};
dataController.getIconForItemWithAPDID = function(d){
    if (d == "") {
        return "ERROR! item missing apdid"
    }
    for (var b in this.table) {
        var c = this.table[b];
        if (c.apdid == d) {
            var a = c.icon;
            a = a.replace("Art/", "/iPad/Contents/" + localizationController.language + "/Art/");
            return a
        }
    }
};
dataController.getFlattenStateForItemWithAPDID = function(c){
    if (c == "" || c == undefined) {
        return ""
    }
    for (var a in this.table) {
        var b = this.table[a];
        if (b.apdid == c) {
            return b.flatten
        }
    }
};
dataController.getBodyForItemWithAPDID = function(d){
    for (var a in this.table) {
        var c = this.table[a];
        if (c.apdid == d) {
            var b = c.content;
            b = b.replace(/Art\//g, "/iPad/Contents/" + localizationController.language + "/Art/");
            return b
        }
    }
    return ""
};
dataController.getBase64ForImageAtPath = function(b){
    for (var a in this.graphics) {
        var c = this.graphics[a];
        if (c.artPath == b) {
            return c.base64
        }
    }
};
dataController.getParentAPDIDForItemWithAPDID = function(a){
    if (a == "" || a == undefined) {
        return ""
    }
    return this.parentTable[a]
};
dataController.getChapterAPDIDForItemWithAPDID = function(b){
    var a = b;
    while (a && this.getParentAPDIDForItemWithAPDID(a) != "TOP_LEVEL_ITEM") {
        a = this.getParentAPDIDForItemWithAPDID(a)
    }
    return a
};
dataController.getBreadcrumbsForItemWithAPDID = function(c){
    var b = "";
    var a = this.getParentAPDIDForItemWithAPDID(c);
    while (a != "TOP_LEVEL_ITEM") {
        b = this.getTitleForItemWithAPDID(a) + " > " + b;
        a = this.getParentAPDIDForItemWithAPDID(a)
    }
    b = b.substring(0, b.length - 2);
    return b
};
dataController.removeEntities = function(a){
    a = a.replace(/&amp;/g, "&");
    a = a.replace(/&lt;/g, "<");
    a = a.replace(/&gt;/g, ">");
    return a
};
function dataControllerInit(){
    dataController.init()
}

window.addEventListener("load", dataControllerInit, false);
dataController.initDatabase = function(){
    try {
        if (!window.openDatabase) {
            alert("not supported")
        }
        else {
            var g = window.location.toString();
            var d = g.lastIndexOf("/");
            if (d != -1) {
                g = g.substring(0, d + 1)
            }
            var a = "User Guide - " + g;
            var c = "1.0";
            var b = "User Guide";
            var h = 65536;
            this.database = openDatabase(a, c, b, h)
        }
    } 
    catch (f) {
        alert("Unknown error " + f + ".");
        return
    }
    this.checkDatabaseVersion()
};
dataController.checkDatabaseVersion = function(){
    this.database.transaction(function(e){
        var a = new XMLHttpRequest();
        var c = dataController.dataFolder + "contentjson-version.txt";
        a.open("GET", c, false);
        try {
            a.send(null)
        } 
        catch (b) {
            a = null
        }
        if (!a || !(a.status == 0 || a.status == 200)) {
            console.log("Error retrieving JSON Version file.");
            var d = ""
        }
        else {
            var d = a.responseText
        }
        e.executeSql("SELECT * FROM " + localizationController.language + 'Config WHERE key="version"', [], function(h, f){
            var g = f.rows.item(0).value;
            dataController.databaseVersion = g;
            if (g == d || d == "") {
                dataController.createDataStructure();
                dataController.createGraphicsDataStructure();
                return
            }
            h.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Content;", [], null, dataController.errorHandler);
            h.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Config;", [], null, dataController.errorHandler);
            h.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Graphics;", [], null, dataController.errorHandler);
            dataController.updateDatabaseVersion(d)
        }, function(g, f){
            dataController.updateDatabaseVersion(d)
        })
    })
};
dataController.updateDatabaseVersion = function(a){
    this.database.transaction(function(b){
        dataController.databaseVersion = a;
        b.executeSql("CREATE TABLE " + localizationController.language + "Config (key TEXT NOT NULL, value TEXT NOT NULL);", [], null, dataController.errorHandler);
        b.executeSql("insert into " + localizationController.language + "Config (key, value) VALUES (?, ?);", ["version", a], null, dataController.errorHandler);
        dataController.createTable();
        dataController.createGraphicsTable()
    })
};
dataController.createTable = function(){
    this.database.transaction(function(transaction){
        console.log("Loaded new JSON data into the Database.");
        var jsonRequest = new XMLHttpRequest();
        var jsonURL = dataController.dataFolder + "content.json";
        jsonRequest.open("GET", jsonURL, false);
        try {
            jsonRequest.send(null)
        } 
        catch (err) {
            jsonRequest = null
        }
        if (!jsonRequest || !(jsonRequest.status == 0 || jsonRequest.status == 200)) {
            console.log("Error retrieving JSON file.");
            return
        }
        try {
            var jsonObject = jsonRequest.responseText;
            eval(jsonObject);
            dataController.graphicCacheFromJSON = graphicCache
        } 
        catch (err) {
            if (localizationController.language != "en") {
                document.location = "?lang=en"
            }
            else {
                alert("English content.json could not be parsed.")
            }
            return
        }
        transaction.executeSql("CREATE TABLE " + localizationController.language + "Content (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, apdid TEXT NOT NULL, parentapdid TEXT NOT NULL, flatten TEXT NOT NULL, title TEXT NOT NULL, icon TEXT NOT NULL, keywords TEXT NOT NULL, content TEXT NOT NULL);", [], null, dataController.errorHandler);
        addItemsInArrayWithParentAPDID(jsonArray, "TOP_LEVEL_ITEM");
        function addItemsInArrayWithParentAPDID(array, parentAPDID){
            for (var i in array) {
                var item = array[i];
                var flatten = 0;
                if (item.flatten && item.children && item.children.length != 0) {
                    flatten = 1
                }
                var name = item.name;
                var icon = item.icon;
                var keywords = item.keywords;
                var content = item.content;
                if (typeof(name) == "undefined") {
                    name = ""
                }
                if (typeof(icon) == "undefined") {
                    icon = ""
                }
                if (typeof(keywords) == "undefined") {
                    keywords = ""
                }
                if (typeof(content) == "undefined") {
                    content = ""
                }
                if (content == "" && item.intro) {
                    content = item.intro
                }
                addEntryToContentDatabase(item.apdid, parentAPDID, flatten, name, icon, keywords, content);
                if (item.children && item.children.length != 0) {
                    addItemsInArrayWithParentAPDID(item.children, item.apdid)
                }
            }
        }
        function addEntryToContentDatabase(apdid, parentapdid, flatten, title, icon, keywords, content){
            transaction.executeSql("insert into " + localizationController.language + "Content (apdid, parentapdid, flatten, title, icon, keywords, content) VALUES (?, ?, ?, ?, ?, ?, ?);", [apdid, parentapdid, flatten, title, icon, keywords, content], null, dataController.errorHandler)
        }
        for (var key in configurationSettings) {
            var value = configurationSettings[key];
            transaction.executeSql("insert into " + localizationController.language + "Config (key, value) VALUES (?, ?);", [key, value], null, dataController.errorHandler)
        }
        dataController.createDataStructure()
    })
};
dataController.createGraphicsTable = function(){
    this.database.transaction(function(d){
        console.log("Loaded new Graphics data into the Database.");
        d.executeSql("CREATE TABLE " + localizationController.language + "Graphics (id INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT, artPath TEXT NOT NULL, base64 TEXT NOT NULL);", [], null, dataController.errorHandler);
        var b = dataController.graphicCacheFromJSON;
        if (typeof(b) != "undefined") {
            for (var a in b) {
                var c = b[a];
                e(a, c)
            }
        }
        function e(g, f){
            d.executeSql("insert into " + localizationController.language + "Graphics (artPath, base64) VALUES (?, ?);", [g, f], null, dataController.errorHandler)
        }
        dataController.createGraphicsDataStructure()
    })
};
dataController.createDataStructure = function(){
    this.database.transaction(function(a){
        a.executeSql("select * from " + localizationController.language + "Content;", [], function(e, b){
            for (var c = 0; c < b.rows.length; c++) {
                var d = b.rows.item(c);
                dataController.table.push(d);
                dataController.titleTable[d.apdid] = d.title;
                dataController.parentTable[d.apdid] = d.parentapdid;
                if (!dataController.childrenTable[d.parentapdid]) {
                    dataController.childrenTable[d.parentapdid] = new Array()
                }
                if (d.apdid != "COPYRIGHT_PAGE_CONTENT" && d.apdid != "COPYRIGHT_TAGLINE") {
                    dataController.childrenTable[d.parentapdid].push(d.apdid)
                }
            }
            dataController.fixNestedSingularChildren();
            dataController.showCopyright = ("" != dataController.getBodyForItemWithAPDID("COPYRIGHT_PAGE_CONTENT") || "" != dataController.getBodyForItemWithAPDID("COPYRIGHT_TAGLINE"));
            dataController.database.transaction(function(f){
                f.executeSql("select * from " + localizationController.language + "Config;", [], function(k, g){
                    for (var h = 0; h < g.rows.length; h++) {
                        var j = g.rows.item(h);
                        dataController.configurationSettings[j.key] = j.value;
                        if (j.key == "MenuStructure" && j.value == "Type=grouped,") {
                            dataController.shouldFlatten = 1
                        }
                        if (j.key == "Search" && j.value == "disabled=true,") {
                            dataController.shouldHideSearchButton = 1
                        }
                        if (j.key == "BackButtonURL" && j.value != "" && j.value != "BackButtonURL") {
                            dataController.mainTOCBackButtonURL = j.value
                        }
                        if (j.key == "BackButtonTitle" && j.value != "" && j.value != "BackButtonTitle") {
                            dataController.mainTOCBackButtonTitle = j.value
                        }
                        if (j.key == "Title" && j.value != "") {
                            dataController.title = j.value;
                            document.title = dataController.title
                        }
                        if (j.key == "AlternativeTitle" && j.value != "") {
                            dataController.alternativeTitle = j.value
                        }
                        if (j.key == "ShowVersionNumber" && j.value == "1") {
                            dataController.showVersionNumber = 1
                        }
                        if (j.key == "WebclipIcon") {
                            dataController.webclipIcon = j.value
                        }
                        if (j.key == "View" && j.value == "Type=single-view,") {
                            dataController.singleViewMode = 1
                        }
                        if (j.key == "TopLevelDisplay" && j.value == "Type=group,") {
                            dataController.showGroupedTopLevel = 1
                        }
                    }
                    controller.showInterface()
                }, dataController.errorHandler)
            })
        }, dataController.errorHandler)
    })
};
dataController.createGraphicsDataStructure = function(){
    this.database.transaction(function(a){
        a.executeSql("select * from " + localizationController.language + "Graphics;", [], function(d, b){
            for (var c = 0; c < b.rows.length; c++) {
                dataController.graphics.push(b.rows.item(c))
            }
        }, dataController.errorHandler)
    })
};
dataController.performSearchWithQuery = function(b, a){
    if (b == "" || b.length < 2) {
        a(new Array());
        return
    }
    b = b.replace(/^\s\s*/, "").replace(/\s\s*$/, "");
    searchQueryArray = b.split(" ");
    searchQueryContentLikeClause = '( content LIKE "%' + searchQueryArray.join('%" AND content LIKE "%') + '%" )';
    searchQueryTitleLikeClause = '( title LIKE "%' + searchQueryArray.join('%" AND title LIKE "%') + '%" )';
    searchQueryKeywordsLikeClause = '( keywords LIKE "%' + searchQueryArray.join('%" AND keywords LIKE "%') + '%" )';
    this.database.transaction(function(d){
        var c = "SELECT * FROM " + localizationController.language + "Content WHERE " + searchQueryContentLikeClause + " OR " + searchQueryTitleLikeClause + " OR " + searchQueryKeywordsLikeClause + " LIMIT 25";
        d.executeSql(c, [], function(f, o){
            var l = new Array();
            for (var h = 0; h < o.rows.length; h++) {
                var k = o.rows.item(h).apdid;
                if (0 != dataController.getChildrenAPDIDsForItemWithAPDID(k).length) {
                    continue
                }
                if (k == "COPYRIGHT_PAGE_CONTENT" || k == "COPYRIGHT_TAGLINE") {
                    continue
                }
                var m = dataController.getBodyForItemWithAPDID(k);
                m = m.replace(/<\/?[^>]+(>|$)/g, " ").replace(/\s+/g, " ");
                var n = false;
                for (var g = 0; searchQueryArrayItem = searchQueryArray[g++];) {
                    searchQueryArrayItem = String(searchQueryArrayItem).replace(/([.*+?^=!:${}()|[\]\/\\])/g, "\\$1");
                    var e = new RegExp(searchQueryArrayItem, "i");
                    if (!e.exec(m)) {
                        n = true;
                        break
                    }
                }
                if (n) {
                    continue
                }
                l.push(k)
            }
            a(l)
        }, dataController.errorHandler)
    })
};
dataController.errorHandler = function(b, a){
    console.log("Error Handler: " + a.message + " (" + a.code + ")");
    if (-1 != a.message.indexOf("no such table")) {
        dataController.database.transaction(function(c){
            c.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Content;", [], null, dataController.errorHandler);
            c.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Config;", [], null, dataController.errorHandler);
            c.executeSql("DROP TABLE IF EXISTS " + localizationController.language + "Graphics;", [], null, dataController.errorHandler);
            window.location.reload()
        })
    }
    return true
};